package org.wfc.omada.api.hotspot.model;

import com.fasterxml.jackson.annotation.JsonProperty;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

import javax.validation.constraints.NotNull;
import java.util.Objects;

/**
 * Custom configuration rate limit.
 */
@ApiModel(description = "Custom configuration rate limit.")
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.SpringCodegen", date = "2024-12-04T11:35:35.496+08:00[Asia/Shanghai]")

public class CustomRateLimitOpenApiVo   {
  @JsonProperty("downLimitEnable")
  private Boolean downLimitEnable;

  @JsonProperty("downLimit")
  private Long downLimit;

  @JsonProperty("upLimitEnable")
  private Boolean upLimitEnable;

  @JsonProperty("upLimit")
  private Long upLimit;

  public CustomRateLimitOpenApiVo downLimitEnable(Boolean downLimitEnable) {
    this.downLimitEnable = downLimitEnable;
    return this;
  }

  /**
   * Whether to enable downlink speed limit.
   * @return downLimitEnable
  */
  @ApiModelProperty(required = true, value = "Whether to enable downlink speed limit.")
  @NotNull


  public Boolean getDownLimitEnable() {
    return downLimitEnable;
  }

  public void setDownLimitEnable(Boolean downLimitEnable) {
    this.downLimitEnable = downLimitEnable;
  }

  public CustomRateLimitOpenApiVo downLimit(Long downLimit) {
    this.downLimit = downLimit;
    return this;
  }

  /**
   * Downlink speed limit in Kbps. The value of limit should be within the range of 0–10485760(Kbps).
   * @return downLimit
  */
  @ApiModelProperty(value = "Downlink speed limit in Kbps. The value of limit should be within the range of 0–10485760(Kbps).")


  public Long getDownLimit() {
    return downLimit;
  }

  public void setDownLimit(Long downLimit) {
    this.downLimit = downLimit;
  }

  public CustomRateLimitOpenApiVo upLimitEnable(Boolean upLimitEnable) {
    this.upLimitEnable = upLimitEnable;
    return this;
  }

  /**
   * Whether to enable uplink speed limit.
   * @return upLimitEnable
  */
  @ApiModelProperty(required = true, value = "Whether to enable uplink speed limit.")
  @NotNull


  public Boolean getUpLimitEnable() {
    return upLimitEnable;
  }

  public void setUpLimitEnable(Boolean upLimitEnable) {
    this.upLimitEnable = upLimitEnable;
  }

  public CustomRateLimitOpenApiVo upLimit(Long upLimit) {
    this.upLimit = upLimit;
    return this;
  }

  /**
   * Uplink speed limit in Kbps. The value of limit should be within the range of 0–10485760(Kbps).
   * @return upLimit
  */
  @ApiModelProperty(value = "Uplink speed limit in Kbps. The value of limit should be within the range of 0–10485760(Kbps).")


  public Long getUpLimit() {
    return upLimit;
  }

  public void setUpLimit(Long upLimit) {
    this.upLimit = upLimit;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    CustomRateLimitOpenApiVo customRateLimitOpenApiVo = (CustomRateLimitOpenApiVo) o;
    return Objects.equals(this.downLimitEnable, customRateLimitOpenApiVo.downLimitEnable) &&
        Objects.equals(this.downLimit, customRateLimitOpenApiVo.downLimit) &&
        Objects.equals(this.upLimitEnable, customRateLimitOpenApiVo.upLimitEnable) &&
        Objects.equals(this.upLimit, customRateLimitOpenApiVo.upLimit);
  }

  @Override
  public int hashCode() {
    return Objects.hash(downLimitEnable, downLimit, upLimitEnable, upLimit);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class CustomRateLimitOpenApiVo {\n");
    
    sb.append("    downLimitEnable: ").append(toIndentedString(downLimitEnable)).append("\n");
    sb.append("    downLimit: ").append(toIndentedString(downLimit)).append("\n");
    sb.append("    upLimitEnable: ").append(toIndentedString(upLimitEnable)).append("\n");
    sb.append("    upLimit: ").append(toIndentedString(upLimit)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
}

